var GOOGLE_URL = "https://www.google.com/youtube/accounts/registerDevice";
/* Samsung id/serial# */
var GOOGLE_DEVELOPER_ID = "AI39si6KOGJrNA6RGfv_wH3ue3UYrEHPxYdT5_VrTrO9u1GLawmoPeVh4rcxrm76zappiyNoI0nEt3jaVWjBFT7ffEKRIfWEyQ";
var GOOGLE_DEVELOPER_SERIAL = "3Vo4JUYhWZvfWWpdFWGdGw==";

var YOUTUBE_API_URL = "http://gdata.youtube.com";
var YOUTUBE_CLIENT_ID = "ytapi-samsung-tv";
/* from Wiki sample code */
//var GOOGLE_DEVELOPER_ID = "AI39si7jB9CE4nuJ3u1PT0-XJwSjZJ3WwJWV2YVHwZxmKvI-2U7gMDc0cQCw0Nc7GOxCLObL3NSnY9AkJ5wKU_0KUmo_7BFMKA";
//var GOOGLE_DEVELOPER_SERIAL = "uyHHAxsv/SWFb/GNkz9Suw==";


var READY_STATE_UNINITIALIZED = 0;
var READY_STATE_LOADING = 1;
var READY_STATE_LOADED = 2;
var READY_STATE_INTERACTIVE = 3;
var READY_STATE_COMPLETE = 4;

var xmlHttpDevice = null;

var base64DeveloperSecret;
var rawAESKey;
var deviceID = "";
var base64DeviceKey;
var rawEnDeviceKey;
var finalDeviceKey = "";;
var digestSign64 = "";
var blockSizeInBits = 128;
var keySizeInBits = 128;
var g_bFromError = false;

parser = new Parser();
function Parser() {
	var returnStr="";
	var tempValue;
	this.response = function (response) {
		return response.split (/[=\n]/g);
	}
	this.mergerHex = function (str) {
		returnStr="";
		for (i in str)
			returnStr += ((str[i] < 16)? "0" : "") + str[i].toString(16);
		return returnStr;	
	}
	this.strToHex = function (str) {
		returnStr="";
		for (i=0; i<str.length; i++) {
			tempValue = eval(str.charCodeAt(i));
			if (tempValue != 0)
				returnStr += ((tempValue < 16)? "0" : "") + tempValue.toString(16) + "";
		}
		return returnStr;
	}
	this.strToDec = function (str) {
		returnStr="";
		for (i=0; i<str.length; i++) {
			tempValue = eval(str.charCodeAt(i));
			returnStr += tempValue + " ";
		}
	return returnStr;
	}

      /* added to process decrypted string */
      this.byteArrayToString = function (buf){
		returnStr="";
            for(i =0;i<buf.length;i++)
            {
            returnStr += String.fromCharCode(buf[i]);
            }
      return returnStr;
      }

      /* added to process decrypted string */
      this.removePaddingByteArrayToString = function (buf){
		returnStr="";
            j=buf[buf.length-1];
            for(i =0;i<buf.length;i++)
            {
               if(i>=(buf.length-j))
                   if (j == buf[i]) continue;
               returnStr += String.fromCharCode(buf[i]);
            }
      return returnStr;
      }
}

function getDeviceKey( bFromError ) {
	TRACE("getDeviceKey");
	TRACE("bFromError = " + bFromError);
	g_bFromError = bFromError;
	var googleURL = GOOGLE_URL;
	var devID = GOOGLE_DEVELOPER_ID;
	var devSerial = GOOGLE_DEVELOPER_SERIAL;
	var params = "developer=" + escape(devID);
	params += "&serialNumber=" + escape(devSerial);
	bDeviceLock = true;
	loadDeviceInfoXML(googleURL, params )	;
}

function loadDeviceInfoXML(url, param) {
	TRACE("loadDeviceInfoXML");
    if (window.XMLHttpRequest) 	{
        // code for Mozilla, etc.        
        if(xmlHttpDevice==null) {
            xmlHttpDevice=new XMLHttpRequest();
        }else{
			xmlHttpDevice.destroy();
			xmlHttpDevice=new XMLHttpRequest();
		}
    } else if (window.ActiveXObject) {
        // code for IE
		if(xmlHttpDevice==null)
        	xmlHttpDevice = new ActiveXObject("Microsoft.XMLHTTP")
    }
    if (xmlHttpDevice!=null) {
		startLoadingonList();
        xmlHttpDevice.onreadystatechange=onLoadDeviceIDnKey;
//		alert(url);
        xmlHttpDevice.open("POST",url,true);
		xmlHttpDevice.setRequestHeader('Content-Type', 'application/x-www-form-urlencoded');
//		alert(param);
        xmlHttpDevice.send(param);
    }
    else 	{
        TRACE("Your browser does not support XMLHTTP.", INFO);
		bDeviceLock = false;
    }	
}

function onLoadDeviceIDnKey() {
	if ( checkReadyState(xmlHttpDevice, "xmlHttpDevice") ) {
		TRACE("onLoadDeviceIDnKey");
		deviceID = "";
		var response = xmlHttpDevice.responseText;
		var responseArray = parser.response (response);
		deviceID = responseArray[1];
		base64DeviceKey  = responseArray[3];
		
		base64DeveloperSecret = GOOGLE_DEVELOPER_SERIAL;
      	/* descripted developer secret */
		rawAESKey = hex2s (parser.strToHex(decode64 (base64DeveloperSecret)));
//		TRACE("base64DeveloperSecret = "+ base64DeveloperSecret);
//		TRACE("rawAESKey = " + parser.strToDec(rawAESKey) );

      	/* descripted device key */
		rawEnDeviceKey = hex2s (parser.strToHex(decode64 (base64DeviceKey)));	
//		TRACE("base64DeviceKey = " + base64DeviceKey);
//		TRACE("rawEnDeviceKey = " + parser.strToDec(rawEnDeviceKey));

     	/* rewrite the logic to create finalDeviceKey */
     	//	finalDeviceKey = makeFinalDeviceKey (rawEnDeviceKey);
      	var decrypted = rijndaelDecrypt(rawEnDeviceKey, rawAESKey);
//		TRACE( "decrypted array = "+ parser.byteArrayToString(decrypted) );
//		TRACE( "decrypted array in dec = " + parser.strToDec(parser.byteArrayToString(decrypted)) );
      	finalDeviceKey = parser.removePaddingByteArrayToString(decrypted); 
//		TRACE( "finalDeviceKey in String = " + finalDeviceKey );
//		TRACE( "finalDeviceKey in Dec = " + parser.strToDec(finalDeviceKey) );
		
		stopLoadingonList();
		bDeviceLock = false;
		
		TRACE("g_bFromError = " + g_bFromError);
		if ( g_bFromError == true ) {
			TRACE("bFromError so don't call loadXML");
			return; // 인증 에러나서 재 시도시 또 컨텐츠 읽으러가면 무한반복됨 
		}
		// DeviceKey를 가지고 오고나면 Category를 읽으러감
//		loadXMLDoc(categoryListXmlURL, categoryID);
		// DeviceKey를 가지고 오고나면 Contents를 읽으러감
        //loadXMLDoc(contentsListXmlURL[0], contentsID);
		
//    	loadXMLDoc( makeFeedUrl(lastCategoryIndex), contentsID );	 		
		if(!goSearch){
			loadXMLDoc( makeFeedUrl(lastCategoryIndex), contentsID );	 		 
		} else {
			onEnter(searchKeyword);
		}			 
	}
}

function requestSigning (xmlUrl) {
	TRACE("requestSigning");
	digestSign64 = ""; // 값 초기화 

	if ( xmlUrl && xmlUrl.length == 0 ){
		TRACE("No xmlUrl !!",TRACE_LEVEL.INFO);
		return false;
	}
      /* here the URL do not need to be encoded */
      //	signingPath = encodeURIComponent ("/feeds/api/standardfeeds/most_viewed?time=today&alt=rss&format=3");
	var digestSign ="";
	var signingPath = getSigningPath(xmlUrl); 

	TRACE("finalDeviceKey length= " + finalDeviceKey.length);
	if ( signingPath.length > 0 && finalDeviceKey.length > 0 ) {
		digestSign = hex_hmac_sha1(finalDeviceKey,signingPath);
	}
	TRACE("digestSign length = " + digestSign.length);
	if ( !digestSign || digestSign.length <= 0 ) {
		TRACE ("hex_hmac_sha1 FAILED!",TRACE_LEVEL.WARN);
		return false;
	}

	digestSign64 = encode64(hex2s(digestSign));
	
//	TRACE("digestSign = " + digestSign);
//	TRACE("encode64(digestSign) = " + digestSign64);
	return true;
}

function getSigningPath( strURL ) {
	var strReturn = "";
	var nIndex = 0;
	var urlLength = strURL.length;
	if ( urlLength <= 0 )	 {
		return strReturn;
	}
	nIndex = strURL.indexOf(YOUTUBE_API_URL);
	if ( nIndex > -1 ) {
		strReturn = strURL.substring(YOUTUBE_API_URL.length);
	}
	//TRACE( "signingPath : " + strReturn);
	return strReturn;
}

function getParam( strURL ) {
	var strReturn = "";
	var nIndex = 0;
	var urlLength = strURL.length;
	if ( urlLength <= 0 )	 {
		return strReturn;
	}
	nIndex = strURL.indexOf("?");
	if ( nIndex > -1 ) {
		strReturn = strURL.substring(nIndex+1);
	}
	//TRACE( "params : " + strReturn );
	return strReturn;	
}